////////////////////////////////////////////////////////////////
//
//  wrapper class for 1d histograms
//
//
#include "single_top_analysis/myTH2F.hpp"
#include "single_top_analysis/Particles.hpp"

using namespace std;

//-----------------------------------------------------------------
// Create the same histogram in several different directories
myTH2F::myTH2F(TDirectory *baseDir,Particles *obj,const std::string& name, const std::string& title,
	       int nXBins, Double_t xMin, Double_t xMax,
	       int nYBins, Double_t yMin, Double_t yMax): _obj(obj)
{
  //Create directories
  baseDir->cd();
  //// both s- and t-channel
  //if(! baseDir->GetKey("inclusive")) baseDir->mkdir("inclusive");

  //
  // now Create histograms and store pointers to them.
  //baseDir->cd("inclusive");
  _hincl=new TH2F(name.c_str(),title.c_str(),nXBins,xMin,xMax,nYBins,yMin,yMax);  

}

//-----------------------------------------------------------------
// fill each of the histograms
int myTH2F::Fill(Double_t x, Double_t y)
{
  //
  // the weight is given by something (well if we use it)
  // for now, Set it to 1.
  Double_t weight=_obj->eventWeight;
  //Double_t weight=1.;


  _hincl->Fill(x,y,weight);
    
  return 0;
}

//----------------------------------------------------------------
// write histograms to the output file
int myTH2F::Write(TDirectory *baseDir)
{
  // now Create histograms and store pointers to them.
  //baseDir->cd("inclusive");
  _hincl->Write();  
  
  return 0;
}

//----------------------------------------------------------------
// copy the content of this histogram into the other
int myTH2F::Copy(myTH2F other)
{
  // call the copy method for each histogram
  _hincl->Copy(*(other._hincl));  
  
  return 0;
}

//----------------------------------------------------------------
//divide the content of this histogram by the other
int myTH2F::Divide(myTH2F other)
{
  // call the divide method for each histogram
  _hincl->Divide(other._hincl);  
  
  return 0;
}

//----------------------------------------------------------------
// Set the labels for the X axis bins individually
void myTH2F::SetXAxisBinLabel(Int_t iBin,TString label)
{
  // call the method for each histogram
  // to Set the bin label on the X axis
  _hincl->GetXaxis()->SetBinLabel(iBin,label);  
  
  return;
}

//----------------------------------------------------------------
// Set the labels for the Y axis bins individually
void myTH2F::SetYAxisBinLabel(Int_t iBin,TString label)
{
  // call the method for each histogram
  // to Set the bin label on the Y axis
  _hincl->GetYaxis()->SetBinLabel(iBin,label);  
  
  return;
}
